enum IGExceptionType { 
  Uncaught,

  /// 无效的参数
  InvalidParameters,

  /// 无效的Model, from make.retnil.cond.throws
  InvalidModel,

  /// 远程服务器内部错误 状态码500
  ServerInternal,

  /// 返回的内容不是预期格式,通常是json
  UnexpectedFormat,

  /// 非常规的错误状态, 常规状态应该是status="fail"
  AbnormalErrorStatus,

  /// 登录时账号或密码错误
  InvalidCredentials,

  /// 登录触发安全验证
  ChallengeRequired,

  /// 登录触发双重验证
  TwoFactorRequired,

  /// 短信验证码输入错误
  InvalidSmsCode,

  /// 当前验证会话已失效
  InvalidNonce,

  /// 未登录或登录凭据失效
  LoginRequired,
  
  /// 多种情形
  FeedbackRequired,

  /// API请求被拒绝 多种情形
  APIRejected
}

class IGException implements Exception {
  final IGExceptionType type;
  final String message;
  final dynamic extra;

  IGException([this.type = IGExceptionType.Uncaught, this.message = "unknow", this.extra]);

  String toString() {
    return "IGException<$type>: $message";
  }
}
